<div class="mainBox">
<h2><a name="ref" id="ref">Ruby-Asp Class Reference Manual</a></h2>
<ul>
<li><a href="#ref-session">$Session</a></li>
<li><a href="#ref-request">$Request</a></li>
<li><a href="#ref-response">$Response</a></li>
<li><a href="#ref-server">$Server</a></li>
<li><a href="#ref-application">$Application</a></li>
<li><a href="#ref-common">Asp::Common</a></li>
</ul>
</div>

<div class="interBox">[<a href="#idx-top">top</a>]</div>

<div class="mainBox">
<h2><a name="ref-session" id="ref-session">$Session</a></h2>
<dl>
<dt><tt><b>$Session[key]</b></tt></dt><dd>
</dd>

<dt><tt><b>$Session[key] = value</b></tt></dt><dd>
</dd>

<dt><tt><b>$Session.timeout( minutes )</b></tt></dt><dd>
      Timeout property, if minutes is being assigned, sets this default timeout for 
      the user session.
</dd>
  
<dt><tt><b>$Session.sessionID</b></tt></dt><dd>
      SessionID property, returns the id for the current session, which is 
      exchanged between the client and the server as a cookie.
</dd>
  
<dt><tt><b>$Session.abandon</b></tt></dt><dd>
      The abandon method times out the session immediately.
</dd>
</dl>
</div>

<div class="interBox">[<a href="#idx-top">top</a>]</div>

<div class="mainBox">
<h2><a name="ref-request" id="ref-request">$Request</a></h2>
<dl>
<dt><tt><b>$Request.form( data )</b></tt></dt><dd>
      Returns the value of the input of name used in a form with POST method.
</dd>
  
<dt><tt><b>$Request.queryString( data )</b></tt></dt><dd>
      Returns the value of the input of name used in a form with GET method.
</dd>
  
<dt><tt><b>$Request.query( )</b></tt></dt><dd>
      Returns the unparsed query string.
</dd>
  
<dt><tt><b>$Request.cookies( name, [key] )</b></tt></dt><dd>
      Returns the value of the Cookie with name. If a key is specified, then 
      a lookup will be done on the cookie as if it were a query string.
</dd>

<dt><tt><b>$Request.serverVariables( name )</b></tt></dt><dd>
      Returns the value of the server variable / environment variable with name 
      name. If name is not specified, returns a ref to a hash of all the server
      / environment variables data. The following would be a common use of this 
      method:
<pre>
env = $Request.serverVariables();
# env here would be equivalent to the ENV.
</pre>
</dd>

<dt><tt><b>$Request.method</b></tt></dt><dd>
      API extension. Returns the client HTTP request method, as in GET or POST.
</dd>

<dt><tt><b>$Request.totalBytes</b></tt></dt><dd>
      The amount of data sent by the client in the body of the request, usually 
	  the length of the form data. This is the same value as 
<pre>
$Request.serverVariables('CONTENT_LENGTH')
</pre>
</dd>
</dl>
</div>

<div class="interBox">[<a href="#idx-top">top</a>]</div>

<div class="mainBox">
<h2><a name="ref-response" id="ref-response">$Response</a></h2>
<dl>
<dt><tt><b>$Response.write( string )</b></tt></dt><dd>
      Write output to the HTML page.
</dd>
  
<dt><tt><b>$Response.binaryWrite( string )</b></tt></dt><dd>
      Writes binary data to the client.
</dd>
  
<dt><tt><b>$Response.addHeader( key, value )</b></tt></dt><dd>
      Adds a custom header to a web page.
</dd>
  
<dt><tt><b>$Response.appendToLog( message )</b></tt></dt><dd>
      Adds message to the server log.
</dd>
  
<dt><tt><b>$Response.end</b></tt></dt><dd>
      Sends result to client, and immediately exits script.
</dd>
  
<dt><tt><b>$Response.include( filename, *args )</b></tt></dt><dd>
      This API extension calls the routine compiled from asp script in filename 
      with the args *args.
</dd>
  
<dt><tt><b>$Response.trapInclude( filename, *args )</b></tt></dt><dd>
      Calls $Response.include() with same arguments as passed to it, but 
      instead traps the include output buffer and returns it.
</dd>
  
<dt><tt><b>$Response.redirect( url )</b></tt></dt><dd>
      Sends the client a command to go to a different url.
</dd>
  
<dt><tt><b>$Response.cookies( name, [key], value )</b></tt></dt><dd>
      Sets the key or attribute of cookie with name name to the value value.
</dd>
  
<dt><tt><b>$Response.charset = value</b></tt></dt><dd>
      This member when set appends itself to the value of the Content-Type HTTP 
      header.
</dd>
  
<dt><tt><b>$Response.contentType = value</b></tt></dt><dd>
      Sets the MIME type for the current response being sent to the client.
</dd>
  
<dt><tt><b>$Response.expires = time</b></tt></dt><dd>
      Sends a response header to the client indicating the time in SECONDS in which 
      the document should expire.
</dd>
  
<dt><tt><b>$Response.expiresAbsolute. = date</b></tt></dt><dd>
      Sends a response header to the client with date being an absolute time to 
      expire.
</dd>
</dl>
</div>

<div class="interBox">[<a href="#idx-top">top</a>]</div>

<div class="mainBox">
<h2><a name="ref-server" id="ref-server">$Server</a></h2>
<dl>
<dt><tt><b>$Server.file( )</b></tt></dt><dd>
      Returns the absolute file path to current executing script.
</dd>
  
<dt><tt><b>$Server.html_encode( string )</b></tt></dt><dd>
      Returns an HTML escapes version of string. &amp;, ", &gt;, &lt;, are each escapes with 
      their HTML equivalents.
</dd>
  
<dt><tt><b>$Server.mapPath( url ) </b></tt></dt><dd>
      Given the url, absolute, or relative to the current executing script, this 
      method returns the equivalent filename that the server would translate the 
      request to, regardless or whether the request would be valid.
</dd>
  
<dt><tt><b>$Server.mail( hMailOps, hSMTPOps )</b></tt></dt><dd>
      API extension to send email.
</dd>
  
<dt><tt><b>$Server.url_encode( string )</b></tt></dt><dd>
      Returns the URL-escaped version of the string.
</dd>
  
<dt><tt><b>$Server.url( url, hParams )</b></tt></dt><dd>
      Will return a URL with hParams serialized into a query string.
</dd>
  
<dt><tt><b>$Server.xslt( xsl_data, xml_data ) </b></tt></dt><dd>
      This method takes string for XSL and XML data and returns the XSLT output 
      as a string.
</dd>

<dt><tt><b>$Server.execute( filename, *args )</b></tt></dt><dd>
      Same as $Response.include( filename, *args ).
</dd>
  
<dt><tt><b>$Server.transfer( filename, *args )</b></tt></dt><dd>
      Transfers control to another script. Same as $Response.include( filename, *args ); $Response.end.
</dd>
</dl>
</div>

<div class="interBox">[<a href="#idx-top">top</a>]</div>

<div class="mainBox">
<h2><a name="ref-application" id="ref-application">$Application</a></h2>
<dl>
<dt><tt><b>$Application</b></tt></dt><dd>
      Like the $Session object, you may use the $Application object to store data across the entire life of the application.
</dd>
</dl>
</div>

<div class="interBox">[<a href="#idx-top">top</a>]</div>

<div class="mainBox">
<h2><a name="ref-common" id="ref-common">Asp::Common</a></h2>
<dl>
<dt><tt><b>Asp::Common::version</b></tt></dt>
<dt><tt><b>Asp::Common::sessionID</b></tt></dt>
<dt><tt><b>Asp::Common::url_decode( value )</b></tt></dt>
<dt><tt><b>Asp::Common::url_encode( s )</b></tt></dt>
<dt><tt><b>Asp::Common::html_escape( s )</b></tt></dt>
<dt><tt><b>Asp::Common::time2str( time )</b></tt></dt>
<dt><tt><b>Asp::Common::str2time( time ) (TODO)</b></tt></dt>
<dt><tt><b>Asp::Common::require( file ) (DEPRECATED)</b></tt></dt>
<dt><tt><b>Asp::Common::stateDir</b></tt></dt>
<dt><tt><b>Asp::Common::globalASA</b></tt></dt>
</dl>
</div>

<div class="interBox">[<a href="#idx-top">top</a>]</div>
